% takes a colormap of a fractal and converts it into a binary image.
function r = tobinary(img)
    nrows = size(img,1);
    ncols = size(img,2);
    
    result = ones(nrows,ncols);
    
    for row = 1:nrows
        for col = 1:ncols
            left = col - 1;
            right = col + 1;
            top = row - 1;
            bot = row + 1;
            
            if (left >= 1) && (img(row,left) ~= img(row,col))
                result(row,col) = 0;
            end
            if (right <= ncols) && (img(row,right) ~= img(row,col))
                result(row,col) = 0;
            end
            
            if (top >= 1) && (img(top,col) ~= img(row,col))
                result(row,col) = 0;
            end
            
            if (bot <= nrows) && (img(bot,col) ~= img(row,col))
                result(row,col) = 0;
            end 
            
            if (left >= 1) && (top >= 1) && (img(top,left) ~= img(row,col))
                result(row,col) = 0;
            end
            
            if (right <= ncols) && (top >= 1) && (img(top,right) ~= img(row,col))
                result(row,col) = 0;
            end
            
            if (left >= 1) && (bot <= nrows) && (img(bot,left) ~= img(row,col))
                result(row,col) = 0;
            end
            
            if (right <= ncols) && (bot <= nrows) && (img(bot,right) ~= img(row,col))
                result(row,col) = 0;
            end
        end
    end
    r = result;
end